/* Include files */

#include "blascompat32.h"
#include "ESC_multi_robot_sfun.h"
#include "c10_ESC_multi_robot.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ESC_multi_robot_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c10_debug_family_names[7] = { "nargin", "nargout", "e_minus",
  "state_pre", "B", "delta", "w" };

/* Function Declarations */
static void initialize_c10_ESC_multi_robot(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance);
static void initialize_params_c10_ESC_multi_robot
  (SFc10_ESC_multi_robotInstanceStruct *chartInstance);
static void enable_c10_ESC_multi_robot(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance);
static void disable_c10_ESC_multi_robot(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance);
static void c10_update_debugger_state_c10_ESC_multi_robot
  (SFc10_ESC_multi_robotInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c10_ESC_multi_robot
  (SFc10_ESC_multi_robotInstanceStruct *chartInstance);
static void set_sim_state_c10_ESC_multi_robot
  (SFc10_ESC_multi_robotInstanceStruct *chartInstance, const mxArray *c10_st);
static void finalize_c10_ESC_multi_robot(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance);
static void sf_c10_ESC_multi_robot(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance);
static void initSimStructsc10_ESC_multi_robot
  (SFc10_ESC_multi_robotInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c10_machineNumber, uint32_T
  c10_chartNumber);
static const mxArray *c10_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static real_T c10_emlrt_marshallIn(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance, const mxArray *c10_w, const char_T *c10_identifier);
static real_T c10_b_emlrt_marshallIn(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void c10_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static const mxArray *c10_b_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static int32_T c10_c_emlrt_marshallIn(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void c10_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static uint8_T c10_d_emlrt_marshallIn(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance, const mxArray *c10_b_is_active_c10_ESC_multi_robot, const
  char_T *c10_identifier);
static uint8_T c10_e_emlrt_marshallIn(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void init_dsm_address_info(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c10_ESC_multi_robot(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance)
{
  chartInstance->c10_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c10_is_active_c10_ESC_multi_robot = 0U;
}

static void initialize_params_c10_ESC_multi_robot
  (SFc10_ESC_multi_robotInstanceStruct *chartInstance)
{
  real_T c10_d0;
  real_T c10_d1;
  sf_set_error_prefix_string(
    "Error evaluating data 'B' in the parent workspace.\n");
  sf_mex_import_named("B", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c10_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c10_B = c10_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'delta' in the parent workspace.\n");
  sf_mex_import_named("delta", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c10_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c10_delta = c10_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c10_ESC_multi_robot(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c10_ESC_multi_robot(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c10_update_debugger_state_c10_ESC_multi_robot
  (SFc10_ESC_multi_robotInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c10_ESC_multi_robot
  (SFc10_ESC_multi_robotInstanceStruct *chartInstance)
{
  const mxArray *c10_st;
  const mxArray *c10_y = NULL;
  real_T c10_hoistedGlobal;
  real_T c10_u;
  const mxArray *c10_b_y = NULL;
  uint8_T c10_b_hoistedGlobal;
  uint8_T c10_b_u;
  const mxArray *c10_c_y = NULL;
  real_T *c10_w;
  c10_w = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c10_st = NULL;
  c10_st = NULL;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_createcellarray(2));
  c10_hoistedGlobal = *c10_w;
  c10_u = c10_hoistedGlobal;
  c10_b_y = NULL;
  sf_mex_assign(&c10_b_y, sf_mex_create("y", &c10_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c10_y, 0, c10_b_y);
  c10_b_hoistedGlobal = chartInstance->c10_is_active_c10_ESC_multi_robot;
  c10_b_u = c10_b_hoistedGlobal;
  c10_c_y = NULL;
  sf_mex_assign(&c10_c_y, sf_mex_create("y", &c10_b_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c10_y, 1, c10_c_y);
  sf_mex_assign(&c10_st, c10_y);
  return c10_st;
}

static void set_sim_state_c10_ESC_multi_robot
  (SFc10_ESC_multi_robotInstanceStruct *chartInstance, const mxArray *c10_st)
{
  const mxArray *c10_u;
  real_T *c10_w;
  c10_w = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c10_doneDoubleBufferReInit = TRUE;
  c10_u = sf_mex_dup(c10_st);
  *c10_w = c10_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c10_u,
    0)), "w");
  chartInstance->c10_is_active_c10_ESC_multi_robot = c10_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c10_u, 1)),
     "is_active_c10_ESC_multi_robot");
  sf_mex_destroy(&c10_u);
  c10_update_debugger_state_c10_ESC_multi_robot(chartInstance);
  sf_mex_destroy(&c10_st);
}

static void finalize_c10_ESC_multi_robot(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance)
{
}

static void sf_c10_ESC_multi_robot(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance)
{
  real_T c10_hoistedGlobal;
  real_T c10_b_hoistedGlobal;
  real_T c10_c_hoistedGlobal;
  real_T c10_d_hoistedGlobal;
  real_T c10_e_minus;
  real_T c10_state_pre;
  real_T c10_b_B;
  real_T c10_b_delta;
  uint32_T c10_debug_family_var_map[7];
  real_T c10_nargin = 4.0;
  real_T c10_nargout = 1.0;
  real_T c10_w;
  real_T *c10_b_e_minus;
  real_T *c10_b_state_pre;
  real_T *c10_b_w;
  c10_b_w = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c10_b_state_pre = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c10_b_e_minus = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 5U, chartInstance->c10_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c10_b_e_minus, 0U);
  _SFD_DATA_RANGE_CHECK(*c10_b_state_pre, 1U);
  _SFD_DATA_RANGE_CHECK(*c10_b_w, 2U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c10_B, 3U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c10_delta, 4U);
  chartInstance->c10_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 5U, chartInstance->c10_sfEvent);
  c10_hoistedGlobal = *c10_b_e_minus;
  c10_b_hoistedGlobal = *c10_b_state_pre;
  c10_c_hoistedGlobal = chartInstance->c10_B;
  c10_d_hoistedGlobal = chartInstance->c10_delta;
  c10_e_minus = c10_hoistedGlobal;
  c10_state_pre = c10_b_hoistedGlobal;
  c10_b_B = c10_c_hoistedGlobal;
  c10_b_delta = c10_d_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 7U, 7U, c10_debug_family_names,
    c10_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c10_nargin, 0U, c10_sf_marshallOut,
    c10_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_nargout, 1U, c10_sf_marshallOut,
    c10_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c10_e_minus, 2U, c10_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c10_state_pre, 3U, c10_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c10_b_B, 4U, c10_sf_marshallOut,
    c10_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_b_delta, 5U, c10_sf_marshallOut,
    c10_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_w, 6U, c10_sf_marshallOut,
    c10_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 3);
  if (CV_EML_IF(0, 0, c10_e_minus < -c10_b_delta)) {
    _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 4);
    c10_w = 0.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 5);
    if (CV_EML_IF(0, 1, c10_e_minus > c10_b_delta)) {
      _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 6);
      c10_w = c10_b_B;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 8);
      c10_w = c10_state_pre;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, -8);
  sf_debug_symbol_scope_pop();
  *c10_b_w = c10_w;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 5U, chartInstance->c10_sfEvent);
  sf_debug_check_for_state_inconsistency(_ESC_multi_robotMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc10_ESC_multi_robot
  (SFc10_ESC_multi_robotInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c10_machineNumber, uint32_T
  c10_chartNumber)
{
}

static const mxArray *c10_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  real_T c10_u;
  const mxArray *c10_y = NULL;
  SFc10_ESC_multi_robotInstanceStruct *chartInstance;
  chartInstance = (SFc10_ESC_multi_robotInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_u = *(real_T *)c10_inData;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", &c10_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c10_mxArrayOutData, c10_y);
  return c10_mxArrayOutData;
}

static real_T c10_emlrt_marshallIn(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance, const mxArray *c10_w, const char_T *c10_identifier)
{
  real_T c10_y;
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_w), &c10_thisId);
  sf_mex_destroy(&c10_w);
  return c10_y;
}

static real_T c10_b_emlrt_marshallIn(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  real_T c10_y;
  real_T c10_d2;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_d2, 1, 0, 0U, 0, 0U, 0);
  c10_y = c10_d2;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void c10_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_w;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y;
  SFc10_ESC_multi_robotInstanceStruct *chartInstance;
  chartInstance = (SFc10_ESC_multi_robotInstanceStruct *)chartInstanceVoid;
  c10_w = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_w), &c10_thisId);
  sf_mex_destroy(&c10_w);
  *(real_T *)c10_outData = c10_y;
  sf_mex_destroy(&c10_mxArrayInData);
}

const mxArray *sf_c10_ESC_multi_robot_get_eml_resolved_functions_info(void)
{
  const mxArray *c10_nameCaptureInfo = NULL;
  c10_nameCaptureInfo = NULL;
  sf_mex_assign(&c10_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1));
  return c10_nameCaptureInfo;
}

static const mxArray *c10_b_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_u;
  const mxArray *c10_y = NULL;
  SFc10_ESC_multi_robotInstanceStruct *chartInstance;
  chartInstance = (SFc10_ESC_multi_robotInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_u = *(int32_T *)c10_inData;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", &c10_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c10_mxArrayOutData, c10_y);
  return c10_mxArrayOutData;
}

static int32_T c10_c_emlrt_marshallIn(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  int32_T c10_y;
  int32_T c10_i0;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_i0, 1, 6, 0U, 0, 0U, 0);
  c10_y = c10_i0;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void c10_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_b_sfEvent;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  int32_T c10_y;
  SFc10_ESC_multi_robotInstanceStruct *chartInstance;
  chartInstance = (SFc10_ESC_multi_robotInstanceStruct *)chartInstanceVoid;
  c10_b_sfEvent = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_b_sfEvent),
    &c10_thisId);
  sf_mex_destroy(&c10_b_sfEvent);
  *(int32_T *)c10_outData = c10_y;
  sf_mex_destroy(&c10_mxArrayInData);
}

static uint8_T c10_d_emlrt_marshallIn(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance, const mxArray *c10_b_is_active_c10_ESC_multi_robot, const
  char_T *c10_identifier)
{
  uint8_T c10_y;
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c10_b_is_active_c10_ESC_multi_robot), &c10_thisId);
  sf_mex_destroy(&c10_b_is_active_c10_ESC_multi_robot);
  return c10_y;
}

static uint8_T c10_e_emlrt_marshallIn(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  uint8_T c10_y;
  uint8_T c10_u0;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_u0, 1, 3, 0U, 0, 0U, 0);
  c10_y = c10_u0;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void init_dsm_address_info(SFc10_ESC_multi_robotInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c10_ESC_multi_robot_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3794969334U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(259905854U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3500781981U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(912350531U);
}

mxArray *sf_c10_ESC_multi_robot_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(871472267U);
    pr[1] = (double)(2876936727U);
    pr[2] = (double)(1671531677U);
    pr[3] = (double)(2584799816U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c10_ESC_multi_robot(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"w\",},{M[8],M[0],T\"is_active_c10_ESC_multi_robot\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c10_ESC_multi_robot_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc10_ESC_multi_robotInstanceStruct *chartInstance;
    chartInstance = (SFc10_ESC_multi_robotInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ESC_multi_robotMachineNumber_,
           10,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ESC_multi_robotMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ESC_multi_robotMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ESC_multi_robotMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"e_minus");
          _SFD_SET_DATA_PROPS(1,1,1,0,"state_pre");
          _SFD_SET_DATA_PROPS(2,2,0,1,"w");
          _SFD_SET_DATA_PROPS(3,10,0,0,"B");
          _SFD_SET_DATA_PROPS(4,10,0,0,"delta");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,2,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,151);
        _SFD_CV_INIT_EML_IF(0,0,56,74,86,147);
        _SFD_CV_INIT_EML_IF(0,1,86,108,120,147);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)c10_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)c10_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)c10_sf_marshallIn);

        {
          real_T *c10_e_minus;
          real_T *c10_state_pre;
          real_T *c10_w;
          c10_w = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c10_state_pre = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c10_e_minus = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c10_e_minus);
          _SFD_SET_DATA_VALUE_PTR(1U, c10_state_pre);
          _SFD_SET_DATA_VALUE_PTR(2U, c10_w);
          _SFD_SET_DATA_VALUE_PTR(3U, &chartInstance->c10_B);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance->c10_delta);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ESC_multi_robotMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c10_ESC_multi_robot(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc10_ESC_multi_robotInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c10_ESC_multi_robot((SFc10_ESC_multi_robotInstanceStruct*)
    chartInstanceVar);
  initialize_c10_ESC_multi_robot((SFc10_ESC_multi_robotInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c10_ESC_multi_robot(void *chartInstanceVar)
{
  enable_c10_ESC_multi_robot((SFc10_ESC_multi_robotInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_disable_c10_ESC_multi_robot(void *chartInstanceVar)
{
  disable_c10_ESC_multi_robot((SFc10_ESC_multi_robotInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c10_ESC_multi_robot(void *chartInstanceVar)
{
  sf_c10_ESC_multi_robot((SFc10_ESC_multi_robotInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c10_ESC_multi_robot(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c10_ESC_multi_robot
    ((SFc10_ESC_multi_robotInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c10_ESC_multi_robot();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c10_ESC_multi_robot(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c10_ESC_multi_robot();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c10_ESC_multi_robot((SFc10_ESC_multi_robotInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c10_ESC_multi_robot(SimStruct* S)
{
  return sf_internal_get_sim_state_c10_ESC_multi_robot(S);
}

static void sf_opaque_set_sim_state_c10_ESC_multi_robot(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c10_ESC_multi_robot(S, st);
}

static void sf_opaque_terminate_c10_ESC_multi_robot(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc10_ESC_multi_robotInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c10_ESC_multi_robot((SFc10_ESC_multi_robotInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc10_ESC_multi_robot((SFc10_ESC_multi_robotInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c10_ESC_multi_robot(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c10_ESC_multi_robot((SFc10_ESC_multi_robotInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c10_ESC_multi_robot(SimStruct *S)
{
  /* Actual parameters from chart:
     B delta
   */
  const char_T *rtParamNames[] = { "p1", "p2" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for B*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for delta*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ESC_multi_robot","ESC_multi_robot",10);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ESC_multi_robot","ESC_multi_robot",10,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ESC_multi_robot",
      "ESC_multi_robot",10,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ESC_multi_robot","ESC_multi_robot",
        10,2);
      sf_mark_chart_reusable_outputs(S,"ESC_multi_robot","ESC_multi_robot",10,1);
    }

    sf_set_rtw_dwork_info(S,"ESC_multi_robot","ESC_multi_robot",10);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2946602460U));
  ssSetChecksum1(S,(3973983990U));
  ssSetChecksum2(S,(83861329U));
  ssSetChecksum3(S,(4231208405U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c10_ESC_multi_robot(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ESC_multi_robot", "ESC_multi_robot",10);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c10_ESC_multi_robot(SimStruct *S)
{
  SFc10_ESC_multi_robotInstanceStruct *chartInstance;
  chartInstance = (SFc10_ESC_multi_robotInstanceStruct *)malloc(sizeof
    (SFc10_ESC_multi_robotInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc10_ESC_multi_robotInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c10_ESC_multi_robot;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c10_ESC_multi_robot;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c10_ESC_multi_robot;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c10_ESC_multi_robot;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c10_ESC_multi_robot;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c10_ESC_multi_robot;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c10_ESC_multi_robot;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c10_ESC_multi_robot;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c10_ESC_multi_robot;
  chartInstance->chartInfo.mdlStart = mdlStart_c10_ESC_multi_robot;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c10_ESC_multi_robot;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c10_ESC_multi_robot_method_dispatcher(SimStruct *S, int_T method, void
  *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c10_ESC_multi_robot(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c10_ESC_multi_robot(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c10_ESC_multi_robot(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c10_ESC_multi_robot_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
