#ifndef __c2_ESC_uni_no_dyn_h__
#define __c2_ESC_uni_no_dyn_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c2_ResolvedFunctionInfo;

typedef struct {
  real_T c2_K_grad;
  real_T c2_data_size;
  real_T c2_lpf_constant;
  real_T c2_poly_degree;
  real_T c2_sampling;
  real_T c2_vel_init;
  SimStruct *S;
  int32_T c2_sfEvent;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c2_doneDoubleBufferReInit;
  boolean_T c2_isStable;
  uint8_T c2_is_active_c2_ESC_uni_no_dyn;
  ChartInfoStruct chartInfo;
} SFc2_ESC_uni_no_dynInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c2_ESC_uni_no_dyn_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c2_ESC_uni_no_dyn_get_check_sum(mxArray *plhs[]);
extern void c2_ESC_uni_no_dyn_method_dispatcher(SimStruct *S, int_T method, void
  *data);

#endif
