/* Include files */

#include "blascompat32.h"
#include "ESC_uni_robot_sfun.h"
#include "c7_ESC_uni_robot.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ESC_uni_robot_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c7_debug_family_names[6] = { "nargin", "nargout", "x",
  "obj_mean", "obj_var", "y" };

static const char * c7_b_debug_family_names[6] = { "nargin", "nargout", "x",
  "mean", "variance", "y" };

/* Function Declarations */
static void initialize_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance);
static void initialize_params_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct *
  chartInstance);
static void enable_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance);
static void disable_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance);
static void c7_update_debugger_state_c7_ESC_uni_robot
  (SFc7_ESC_uni_robotInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c7_ESC_uni_robot
  (SFc7_ESC_uni_robotInstanceStruct *chartInstance);
static void set_sim_state_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_st);
static void finalize_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance);
static void sf_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct *chartInstance);
static void initSimStructsc7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber);
static const mxArray *c7_sf_marshallOut(void *chartInstanceVoid, void *c7_inData);
static real_T c7_emlrt_marshallIn(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_y, const char_T *c7_identifier);
static real_T c7_b_emlrt_marshallIn(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static real_T c7_power(SFc7_ESC_uni_robotInstanceStruct *chartInstance, real_T
  c7_a, real_T c7_b);
static void c7_eml_error(SFc7_ESC_uni_robotInstanceStruct *chartInstance);
static const mxArray *c7_b_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static int32_T c7_c_emlrt_marshallIn(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static uint8_T c7_d_emlrt_marshallIn(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_b_is_active_c7_ESC_uni_robot, const char_T
  *c7_identifier);
static uint8_T c7_e_emlrt_marshallIn(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void init_dsm_address_info(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance)
{
  chartInstance->c7_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c7_is_active_c7_ESC_uni_robot = 0U;
}

static void initialize_params_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct *
  chartInstance)
{
  real_T c7_d0;
  real_T c7_d1;
  sf_set_error_prefix_string(
    "Error evaluating data 'obj_mean' in the parent workspace.\n");
  sf_mex_import_named("obj_mean", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c7_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c7_obj_mean = c7_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'obj_var' in the parent workspace.\n");
  sf_mex_import_named("obj_var", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      &c7_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c7_obj_var = c7_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c7_update_debugger_state_c7_ESC_uni_robot
  (SFc7_ESC_uni_robotInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c7_ESC_uni_robot
  (SFc7_ESC_uni_robotInstanceStruct *chartInstance)
{
  const mxArray *c7_st;
  const mxArray *c7_y = NULL;
  real_T c7_hoistedGlobal;
  real_T c7_u;
  const mxArray *c7_b_y = NULL;
  uint8_T c7_b_hoistedGlobal;
  uint8_T c7_b_u;
  const mxArray *c7_c_y = NULL;
  real_T *c7_d_y;
  c7_d_y = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c7_st = NULL;
  c7_st = NULL;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_createcellarray(2));
  c7_hoistedGlobal = *c7_d_y;
  c7_u = c7_hoistedGlobal;
  c7_b_y = NULL;
  sf_mex_assign(&c7_b_y, sf_mex_create("y", &c7_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c7_y, 0, c7_b_y);
  c7_b_hoistedGlobal = chartInstance->c7_is_active_c7_ESC_uni_robot;
  c7_b_u = c7_b_hoistedGlobal;
  c7_c_y = NULL;
  sf_mex_assign(&c7_c_y, sf_mex_create("y", &c7_b_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c7_y, 1, c7_c_y);
  sf_mex_assign(&c7_st, c7_y);
  return c7_st;
}

static void set_sim_state_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_st)
{
  const mxArray *c7_u;
  real_T *c7_y;
  c7_y = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c7_doneDoubleBufferReInit = TRUE;
  c7_u = sf_mex_dup(c7_st);
  *c7_y = c7_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c7_u, 0)),
    "y");
  chartInstance->c7_is_active_c7_ESC_uni_robot = c7_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c7_u, 1)),
     "is_active_c7_ESC_uni_robot");
  sf_mex_destroy(&c7_u);
  c7_update_debugger_state_c7_ESC_uni_robot(chartInstance);
  sf_mex_destroy(&c7_st);
}

static void finalize_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance)
{
}

static void sf_c7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct *chartInstance)
{
  real_T c7_hoistedGlobal;
  real_T c7_b_hoistedGlobal;
  real_T c7_c_hoistedGlobal;
  real_T c7_x;
  real_T c7_b_obj_mean;
  real_T c7_b_obj_var;
  uint32_T c7_debug_family_var_map[6];
  real_T c7_nargin = 3.0;
  real_T c7_nargout = 1.0;
  real_T c7_y;
  real_T c7_b_x;
  real_T c7_mean;
  real_T c7_variance;
  real_T c7_b_nargin = 3.0;
  real_T c7_b_nargout = 1.0;
  real_T c7_b;
  real_T c7_b_y;
  real_T c7_A;
  real_T c7_B;
  real_T c7_c_x;
  real_T c7_c_y;
  real_T c7_d_x;
  real_T c7_d_y;
  real_T c7_e_x;
  real_T c7_e_y;
  real_T c7_f_y;
  real_T c7_f_x;
  real_T c7_g_x;
  real_T c7_b_b;
  real_T c7_g_y;
  real_T *c7_h_x;
  real_T *c7_h_y;
  c7_h_y = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c7_h_x = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 4U, chartInstance->c7_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c7_h_x, 0U);
  _SFD_DATA_RANGE_CHECK(*c7_h_y, 1U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c7_obj_mean, 2U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c7_obj_var, 3U);
  chartInstance->c7_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 4U, chartInstance->c7_sfEvent);
  c7_hoistedGlobal = *c7_h_x;
  c7_b_hoistedGlobal = chartInstance->c7_obj_mean;
  c7_c_hoistedGlobal = chartInstance->c7_obj_var;
  c7_x = c7_hoistedGlobal;
  c7_b_obj_mean = c7_b_hoistedGlobal;
  c7_b_obj_var = c7_c_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 6U, 6U, c7_debug_family_names,
    c7_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c7_nargin, 0U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_nargout, 1U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c7_x, 2U, c7_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_obj_mean, 3U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_obj_var, 4U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_y, 5U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 4);
  c7_b_x = c7_x;
  c7_mean = c7_b_obj_mean;
  c7_variance = c7_b_obj_var;
  sf_debug_symbol_scope_push_eml(0U, 6U, 6U, c7_b_debug_family_names,
    c7_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_nargin, 0U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_nargout, 1U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_b_x, 2U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_mean, 3U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_variance, 4U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_y, 5U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  CV_SCRIPT_FCN(0, 0);
  _SFD_SCRIPT_CALL(0U, chartInstance->c7_sfEvent, 4);
  c7_b = c7_power(chartInstance, c7_b_x - c7_mean, 2.0);
  c7_b_y = -0.5 * c7_b;
  c7_A = c7_b_y;
  c7_B = c7_power(chartInstance, c7_variance, 2.0);
  c7_c_x = c7_A;
  c7_c_y = c7_B;
  c7_d_x = c7_c_x;
  c7_d_y = c7_c_y;
  c7_e_x = c7_d_x;
  c7_e_y = c7_d_y;
  c7_f_y = c7_e_x / c7_e_y;
  c7_f_x = c7_f_y;
  c7_g_x = c7_f_x;
  c7_g_x = muDoubleScalarExp(c7_g_x);
  c7_b_b = c7_g_x;
  c7_g_y = 1.5 * c7_b_b;
  c7_y = 2.5 - c7_g_y;
  _SFD_SCRIPT_CALL(0U, chartInstance->c7_sfEvent, -4);
  sf_debug_symbol_scope_pop();
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, -4);
  sf_debug_symbol_scope_pop();
  *c7_h_y = c7_y;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 4U, chartInstance->c7_sfEvent);
  sf_debug_check_for_state_inconsistency(_ESC_uni_robotMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc7_ESC_uni_robot(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber)
{
  _SFD_SCRIPT_TRANSLATION(c7_chartNumber, 0U, sf_debug_get_script_id(
    "C:/Users/bcalli/Desktop/ESC/ESC_matlab/obj_func_uni.m"));
}

static const mxArray *c7_sf_marshallOut(void *chartInstanceVoid, void *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  real_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_ESC_uni_robotInstanceStruct *chartInstance;
  chartInstance = (SFc7_ESC_uni_robotInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(real_T *)c7_inData;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c7_mxArrayOutData, c7_y);
  return c7_mxArrayOutData;
}

static real_T c7_emlrt_marshallIn(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_y, const char_T *c7_identifier)
{
  real_T c7_b_y;
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_b_y = c7_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_y), &c7_thisId);
  sf_mex_destroy(&c7_y);
  return c7_b_y;
}

static real_T c7_b_emlrt_marshallIn(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  real_T c7_y;
  real_T c7_d2;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_d2, 1, 0, 0U, 0, 0U, 0);
  c7_y = c7_d2;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_y;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_b_y;
  SFc7_ESC_uni_robotInstanceStruct *chartInstance;
  chartInstance = (SFc7_ESC_uni_robotInstanceStruct *)chartInstanceVoid;
  c7_y = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_b_y = c7_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_y), &c7_thisId);
  sf_mex_destroy(&c7_y);
  *(real_T *)c7_outData = c7_b_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

const mxArray *sf_c7_ESC_uni_robot_get_eml_resolved_functions_info(void)
{
  const mxArray *c7_nameCaptureInfo;
  c7_ResolvedFunctionInfo c7_info[12];
  c7_ResolvedFunctionInfo (*c7_b_info)[12];
  const mxArray *c7_m0 = NULL;
  int32_T c7_i0;
  c7_ResolvedFunctionInfo *c7_r0;
  c7_nameCaptureInfo = NULL;
  c7_nameCaptureInfo = NULL;
  c7_b_info = (c7_ResolvedFunctionInfo (*)[12])c7_info;
  (*c7_b_info)[0].context = "";
  (*c7_b_info)[0].name = "obj_func_uni";
  (*c7_b_info)[0].dominantType = "double";
  (*c7_b_info)[0].resolved =
    "[E]C:/Users/bcalli/Desktop/ESC/ESC_matlab/obj_func_uni.m";
  (*c7_b_info)[0].fileTimeLo = 343041216U;
  (*c7_b_info)[0].fileTimeHi = 30210729U;
  (*c7_b_info)[0].mFileTimeLo = 0U;
  (*c7_b_info)[0].mFileTimeHi = 0U;
  (*c7_b_info)[1].context =
    "[E]C:/Users/bcalli/Desktop/ESC/ESC_matlab/obj_func_uni.m";
  (*c7_b_info)[1].name = "mrdivide";
  (*c7_b_info)[1].dominantType = "double";
  (*c7_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c7_b_info)[1].fileTimeLo = 2117098240U;
  (*c7_b_info)[1].fileTimeHi = 30130935U;
  (*c7_b_info)[1].mFileTimeLo = 3573034496U;
  (*c7_b_info)[1].mFileTimeHi = 30114299U;
  (*c7_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c7_b_info)[2].name = "rdivide";
  (*c7_b_info)[2].dominantType = "double";
  (*c7_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c7_b_info)[2].fileTimeLo = 1847391744U;
  (*c7_b_info)[2].fileTimeHi = 30108011U;
  (*c7_b_info)[2].mFileTimeLo = 0U;
  (*c7_b_info)[2].mFileTimeHi = 0U;
  (*c7_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c7_b_info)[3].name = "eml_div";
  (*c7_b_info)[3].dominantType = "double";
  (*c7_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c7_b_info)[3].fileTimeLo = 387391744U;
  (*c7_b_info)[3].fileTimeHi = 30108011U;
  (*c7_b_info)[3].mFileTimeLo = 0U;
  (*c7_b_info)[3].mFileTimeHi = 0U;
  (*c7_b_info)[4].context =
    "[E]C:/Users/bcalli/Desktop/ESC/ESC_matlab/obj_func_uni.m";
  (*c7_b_info)[4].name = "power";
  (*c7_b_info)[4].dominantType = "double";
  (*c7_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c7_b_info)[4].fileTimeLo = 1847391744U;
  (*c7_b_info)[4].fileTimeHi = 30108011U;
  (*c7_b_info)[4].mFileTimeLo = 0U;
  (*c7_b_info)[4].mFileTimeHi = 0U;
  (*c7_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c7_b_info)[5].name = "eml_scalar_eg";
  (*c7_b_info)[5].dominantType = "double";
  (*c7_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  (*c7_b_info)[5].fileTimeLo = 1367391744U;
  (*c7_b_info)[5].fileTimeHi = 30108011U;
  (*c7_b_info)[5].mFileTimeLo = 0U;
  (*c7_b_info)[5].mFileTimeHi = 0U;
  (*c7_b_info)[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c7_b_info)[6].name = "eml_scalexp_alloc";
  (*c7_b_info)[6].dominantType = "double";
  (*c7_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  (*c7_b_info)[6].fileTimeLo = 1367391744U;
  (*c7_b_info)[6].fileTimeHi = 30108011U;
  (*c7_b_info)[6].mFileTimeLo = 0U;
  (*c7_b_info)[6].mFileTimeHi = 0U;
  (*c7_b_info)[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c7_b_info)[7].name = "eml_scalar_floor";
  (*c7_b_info)[7].dominantType = "double";
  (*c7_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  (*c7_b_info)[7].fileTimeLo = 667391744U;
  (*c7_b_info)[7].fileTimeHi = 30108011U;
  (*c7_b_info)[7].mFileTimeLo = 0U;
  (*c7_b_info)[7].mFileTimeHi = 0U;
  (*c7_b_info)[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c7_b_info)[8].name = "eml_error";
  (*c7_b_info)[8].dominantType = "char";
  (*c7_b_info)[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  (*c7_b_info)[8].fileTimeLo = 407391744U;
  (*c7_b_info)[8].fileTimeHi = 30108011U;
  (*c7_b_info)[8].mFileTimeLo = 0U;
  (*c7_b_info)[8].mFileTimeHi = 0U;
  (*c7_b_info)[9].context =
    "[E]C:/Users/bcalli/Desktop/ESC/ESC_matlab/obj_func_uni.m";
  (*c7_b_info)[9].name = "mtimes";
  (*c7_b_info)[9].dominantType = "double";
  (*c7_b_info)[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c7_b_info)[9].fileTimeLo = 3573034496U;
  (*c7_b_info)[9].fileTimeHi = 30114299U;
  (*c7_b_info)[9].mFileTimeLo = 0U;
  (*c7_b_info)[9].mFileTimeHi = 0U;
  (*c7_b_info)[10].context =
    "[E]C:/Users/bcalli/Desktop/ESC/ESC_matlab/obj_func_uni.m";
  (*c7_b_info)[10].name = "exp";
  (*c7_b_info)[10].dominantType = "double";
  (*c7_b_info)[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  (*c7_b_info)[10].fileTimeLo = 807391744U;
  (*c7_b_info)[10].fileTimeHi = 30108011U;
  (*c7_b_info)[10].mFileTimeLo = 0U;
  (*c7_b_info)[10].mFileTimeHi = 0U;
  (*c7_b_info)[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  (*c7_b_info)[11].name = "eml_scalar_exp";
  (*c7_b_info)[11].dominantType = "double";
  (*c7_b_info)[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_exp.m";
  (*c7_b_info)[11].fileTimeLo = 667391744U;
  (*c7_b_info)[11].fileTimeHi = 30108011U;
  (*c7_b_info)[11].mFileTimeLo = 0U;
  (*c7_b_info)[11].mFileTimeHi = 0U;
  sf_mex_assign(&c7_m0, sf_mex_createstruct("nameCaptureInfo", 1, 12));
  for (c7_i0 = 0; c7_i0 < 12; c7_i0++) {
    c7_r0 = &c7_info[c7_i0];
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->context)), "context", "nameCaptureInfo",
                    c7_i0);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c7_r0->name)), "name", "nameCaptureInfo", c7_i0);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c7_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c7_i0);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->resolved)), "resolved", "nameCaptureInfo",
                    c7_i0);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c7_i0);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c7_i0);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c7_i0);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c7_i0);
  }

  sf_mex_assign(&c7_nameCaptureInfo, c7_m0);
  return c7_nameCaptureInfo;
}

static real_T c7_power(SFc7_ESC_uni_robotInstanceStruct *chartInstance, real_T
  c7_a, real_T c7_b)
{
  real_T c7_ak;
  real_T c7_bk;
  real_T c7_x;
  real_T c7_b_x;
  c7_ak = c7_a;
  c7_bk = c7_b;
  if (c7_ak < 0.0) {
    c7_x = c7_bk;
    c7_b_x = c7_x;
    c7_b_x = muDoubleScalarFloor(c7_b_x);
    if (c7_b_x != c7_bk) {
      c7_eml_error(chartInstance);
    }
  }

  return muDoubleScalarPower(c7_ak, c7_bk);
}

static void c7_eml_error(SFc7_ESC_uni_robotInstanceStruct *chartInstance)
{
  int32_T c7_i1;
  static char_T c7_varargin_1[31] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o',
    'o', 'l', 'b', 'o', 'x', ':', 'p', 'o', 'w', 'e', 'r', '_', 'd', 'o', 'm',
    'a', 'i', 'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c7_u[31];
  const mxArray *c7_y = NULL;
  for (c7_i1 = 0; c7_i1 < 31; c7_i1++) {
    c7_u[c7_i1] = c7_varargin_1[c7_i1];
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 10, 0U, 1U, 0U, 2, 1, 31));
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c7_y));
}

static const mxArray *c7_b_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_ESC_uni_robotInstanceStruct *chartInstance;
  chartInstance = (SFc7_ESC_uni_robotInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(int32_T *)c7_inData;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c7_mxArrayOutData, c7_y);
  return c7_mxArrayOutData;
}

static int32_T c7_c_emlrt_marshallIn(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  int32_T c7_y;
  int32_T c7_i2;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_i2, 1, 6, 0U, 0, 0U, 0);
  c7_y = c7_i2;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_b_sfEvent;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  int32_T c7_y;
  SFc7_ESC_uni_robotInstanceStruct *chartInstance;
  chartInstance = (SFc7_ESC_uni_robotInstanceStruct *)chartInstanceVoid;
  c7_b_sfEvent = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_sfEvent),
    &c7_thisId);
  sf_mex_destroy(&c7_b_sfEvent);
  *(int32_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static uint8_T c7_d_emlrt_marshallIn(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_b_is_active_c7_ESC_uni_robot, const char_T
  *c7_identifier)
{
  uint8_T c7_y;
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c7_b_is_active_c7_ESC_uni_robot), &c7_thisId);
  sf_mex_destroy(&c7_b_is_active_c7_ESC_uni_robot);
  return c7_y;
}

static uint8_T c7_e_emlrt_marshallIn(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  uint8_T c7_y;
  uint8_T c7_u0;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_u0, 1, 3, 0U, 0, 0U, 0);
  c7_y = c7_u0;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void init_dsm_address_info(SFc7_ESC_uni_robotInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c7_ESC_uni_robot_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1226788768U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3597545930U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2623247058U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2013134848U);
}

mxArray *sf_c7_ESC_uni_robot_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2410949204U);
    pr[1] = (double)(1869963821U);
    pr[2] = (double)(4230351757U);
    pr[3] = (double)(3109017104U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c7_ESC_uni_robot(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"y\",},{M[8],M[0],T\"is_active_c7_ESC_uni_robot\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c7_ESC_uni_robot_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc7_ESC_uni_robotInstanceStruct *chartInstance;
    chartInstance = (SFc7_ESC_uni_robotInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ESC_uni_robotMachineNumber_,
           7,
           1,
           1,
           4,
           0,
           0,
           0,
           0,
           1,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ESC_uni_robotMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ESC_uni_robotMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ESC_uni_robotMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"x");
          _SFD_SET_DATA_PROPS(1,2,0,1,"y");
          _SFD_SET_DATA_PROPS(2,10,0,0,"obj_mean");
          _SFD_SET_DATA_PROPS(3,10,0,0,"obj_var");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,100);
        _SFD_CV_INIT_SCRIPT(0,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_SCRIPT_FCN(0,0,"obj_func_uni",0,-1,213);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_sf_marshallOut,(MexInFcnForType)c7_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_sf_marshallOut,(MexInFcnForType)c7_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c7_sf_marshallOut,(MexInFcnForType)c7_sf_marshallIn);

        {
          real_T *c7_x;
          real_T *c7_y;
          c7_y = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c7_x = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c7_x);
          _SFD_SET_DATA_VALUE_PTR(1U, c7_y);
          _SFD_SET_DATA_VALUE_PTR(2U, &chartInstance->c7_obj_mean);
          _SFD_SET_DATA_VALUE_PTR(3U, &chartInstance->c7_obj_var);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ESC_uni_robotMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c7_ESC_uni_robot(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc7_ESC_uni_robotInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c7_ESC_uni_robot((SFc7_ESC_uni_robotInstanceStruct*)
    chartInstanceVar);
  initialize_c7_ESC_uni_robot((SFc7_ESC_uni_robotInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c7_ESC_uni_robot(void *chartInstanceVar)
{
  enable_c7_ESC_uni_robot((SFc7_ESC_uni_robotInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c7_ESC_uni_robot(void *chartInstanceVar)
{
  disable_c7_ESC_uni_robot((SFc7_ESC_uni_robotInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c7_ESC_uni_robot(void *chartInstanceVar)
{
  sf_c7_ESC_uni_robot((SFc7_ESC_uni_robotInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c7_ESC_uni_robot(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c7_ESC_uni_robot
    ((SFc7_ESC_uni_robotInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c7_ESC_uni_robot();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c7_ESC_uni_robot(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c7_ESC_uni_robot();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c7_ESC_uni_robot((SFc7_ESC_uni_robotInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c7_ESC_uni_robot(SimStruct* S)
{
  return sf_internal_get_sim_state_c7_ESC_uni_robot(S);
}

static void sf_opaque_set_sim_state_c7_ESC_uni_robot(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c7_ESC_uni_robot(S, st);
}

static void sf_opaque_terminate_c7_ESC_uni_robot(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc7_ESC_uni_robotInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c7_ESC_uni_robot((SFc7_ESC_uni_robotInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc7_ESC_uni_robot((SFc7_ESC_uni_robotInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c7_ESC_uni_robot(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c7_ESC_uni_robot((SFc7_ESC_uni_robotInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c7_ESC_uni_robot(SimStruct *S)
{
  /* Actual parameters from chart:
     obj_mean obj_var
   */
  const char_T *rtParamNames[] = { "p1", "p2" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for obj_mean*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for obj_var*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ESC_uni_robot","ESC_uni_robot",7);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ESC_uni_robot","ESC_uni_robot",7,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ESC_uni_robot",
      "ESC_uni_robot",7,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ESC_uni_robot","ESC_uni_robot",7,1);
      sf_mark_chart_reusable_outputs(S,"ESC_uni_robot","ESC_uni_robot",7,1);
    }

    sf_set_rtw_dwork_info(S,"ESC_uni_robot","ESC_uni_robot",7);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2283869851U));
  ssSetChecksum1(S,(2208622354U));
  ssSetChecksum2(S,(2185616070U));
  ssSetChecksum3(S,(1687664180U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c7_ESC_uni_robot(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ESC_uni_robot", "ESC_uni_robot",7);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c7_ESC_uni_robot(SimStruct *S)
{
  SFc7_ESC_uni_robotInstanceStruct *chartInstance;
  chartInstance = (SFc7_ESC_uni_robotInstanceStruct *)malloc(sizeof
    (SFc7_ESC_uni_robotInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc7_ESC_uni_robotInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c7_ESC_uni_robot;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c7_ESC_uni_robot;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c7_ESC_uni_robot;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c7_ESC_uni_robot;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c7_ESC_uni_robot;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c7_ESC_uni_robot;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c7_ESC_uni_robot;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c7_ESC_uni_robot;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c7_ESC_uni_robot;
  chartInstance->chartInfo.mdlStart = mdlStart_c7_ESC_uni_robot;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c7_ESC_uni_robot;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c7_ESC_uni_robot_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c7_ESC_uni_robot(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c7_ESC_uni_robot(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c7_ESC_uni_robot(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c7_ESC_uni_robot_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
