#ifndef __c1_ESC_multi_no_dyn_h__
#define __c1_ESC_multi_no_dyn_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c1_ResolvedFunctionInfo;

typedef struct {
  real_T c1_K_grad;
  real_T c1_data_size;
  real_T c1_lpf_constant;
  real_T c1_sampling;
  real_T c1_vel_init;
  SimStruct *S;
  int32_T c1_sfEvent;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c1_doneDoubleBufferReInit;
  boolean_T c1_isStable;
  uint8_T c1_is_active_c1_ESC_multi_no_dyn;
  ChartInfoStruct chartInfo;
} SFc1_ESC_multi_no_dynInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c1_ESC_multi_no_dyn_get_eml_resolved_functions_info
  (void);

/* Function Definitions */
extern void sf_c1_ESC_multi_no_dyn_get_check_sum(mxArray *plhs[]);
extern void c1_ESC_multi_no_dyn_method_dispatcher(SimStruct *S, int_T method,
  void *data);

#endif
